#include <stdio.h>
#include <stdlib.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_cdf.h>
//chisquare_fs <rows> <cols> <dataT> <prior>
//rows=rows in dataT and cols=cols in dataT

int main (int argc, char* argv[]) {
  int i, j; float sum=0;
  int rows = atoi(argv[1]); int cols = atoi(argv[2]); 

  gsl_vector * chivals = gsl_vector_alloc(cols);
  gsl_permutation * p = gsl_permutation_alloc(cols);
  gsl_vector * cl = gsl_vector_alloc(rows);

  short** dataT = (short**) malloc(rows*sizeof(short*));
  for(i=0; i<rows; i++){
    dataT[i] = (short*) malloc(cols*sizeof(short));
  }

  { FILE* f = fopen(argv[3], "r");
    for(i=0;i<rows;i++){
      for(j=0;j<cols;j++){
        fscanf(f, "%d", &dataT[i][j]);
      }
    }
//    fclose (f);
  }

/* Inits */
  gsl_vector_set_all(cl, -1);

/* ENABLED PRIORS */
  if(argv[4] != 0) { 
    FILE* f = fopen(argv[4], "rt"); 
    while(fscanf(f, "%d %d", &i, &j) != EOF) gsl_vector_set(cl, j, i); fclose (f); 
  }


  float small, big, small_, big_; 
  float casetotal,controltotal,smalltotal,bigtotal,total;
  float e_casesmall, e_casebig, e_controlsmall, e_controlbig;
  float oe_casesmall, oe_casebig, oe_controlsmall, oe_controlbig;
  float chi;

  for (i = 0; i < cols; i++) {

    small=1; big=1;
    small_=1; big_=1;

    for (j = 0; j < rows; j++){ 
      if(gsl_vector_get(cl, j) != -1 && gsl_vector_get(cl, j) == 0) {
        if(dataT[j][i] == 0) { small+=2; }
        else if (dataT[j][i] == 1) { small++; big++; }
        else if (dataT[j][i] == 2) { big+=2; }
      }
      if(gsl_vector_get(cl, j) != -1 && gsl_vector_get(cl, j) == 1) {
        if(dataT[j][i] == 0) { small_+=2; }
        else if (dataT[j][i] == 1) { small_++; big_++; }
        else if (dataT[j][i] == 2) { big_+=2; }
      }
    }

    casetotal=small+big; 
    controltotal=small_+big_;
    smalltotal=small+small_;
    bigtotal=big+big_;
    total=casetotal+controltotal;

    e_casesmall = casetotal*smalltotal/total;   
    e_casebig = casetotal*bigtotal/total;   
    e_controlsmall = controltotal*smalltotal/total;   
    e_controlbig = controltotal*bigtotal/total;   

    oe_casesmall = (small - e_casesmall)*(small - e_casesmall);
    oe_casebig = (big - e_casebig)*(big - e_casebig);
    oe_controlsmall = (small_ - e_controlsmall)*(small_ - e_controlsmall);
    oe_controlbig = (big_ - e_controlbig)*(big_ - e_controlbig);

    chi = oe_casesmall/e_casesmall + oe_casebig/e_casebig +  
	oe_controlsmall/e_controlsmall + oe_controlbig/e_controlbig; 

    gsl_vector_set(chivals, i, chi);

  }

  gsl_sort_vector_index(p, chivals);
  for(i=cols-1;i>=0;i--) printf("%d ", p->data[i]); printf("\n");
  for(i=cols-1;i>=0;i--) printf("%.5f ", gsl_vector_get(chivals,p->data[i])); printf("\n");
  for(i=cols-1;i>=0;i--) printf("%.5e ", gsl_cdf_chisq_Q(gsl_vector_get(chivals,p->data[i]), 1)); printf("\n");

  return 0;
}
